Systemd-networkd crashes with core dump

Bug #1633274 reported by Halvor Lyche Strandvoll on 2016-10-14
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
systemd
Fix Released
Unknown
systemd (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Unassigned
Yakkety
Undecided
Unassigned
Zesty
Undecided
Unassigned

Bug Description

Systemd-networkd crashes with core dump, this happends in Yakkety and Xenial.

The latest patch that was commited to Xenial-updates and Yakkety is the one that broke this.
Everything works just fine with Xenial without latest update or Yakkety Beta 2.

The log entries i see is:
Oct 14 02:37:42 Router01 systemd-networkd[3402]: Assertion 't' failed at ../src/network/networkd-netdev-tunnel.c:210, function netdev_vti_fill_message_key(). Aborting.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Main process exited, code=dumped, status=6/ABRT
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Unit entered failed state.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Failed with result 'core-dump'.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Service has no hold-off time, scheduling restart.
Oct 14 02:37:42 Router01 systemd[1]: Stopped Network Service.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Start request repeated too quickly.
Oct 14 02:37:42 Router01 systemd[1]: Failed to start Network Service.
Oct 14 02:37:42 Router01 systemd[1]: Dependency failed for Wait for Network to be Configured.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd-wait-online.service: Job systemd-networkd-wait-online.service/start failed with result 'dependency'.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Unit entered failed state.
Oct 14 02:37:42 Router01 systemd[1]: systemd-networkd.service: Failed with result 'start-limit-hit'.

SRU TEST CASE: See https://github.com/systemd/systemd/issues/4371#issuecomment-253697041

Regression potential: Very low, this just fixes an obvious type cast in networkd and touches no code that applies to other network interfaces. The service manager (pid 1) and other tools are entirely unaffected.

ProblemType: Bug
DistroRelease: Ubuntu 16.10
Package: systemd 231-9git1
ProcVersionSignature: Ubuntu 4.8.0-22.24-generic 4.8.0
Uname: Linux 4.8.0-22-generic x86_64
ApportVersion: 2.20.3-0ubuntu8
Architecture: amd64
Date: Fri Oct 14 02:39:05 2016
InstallationDate: Installed on 2016-10-13 (0 days ago)
InstallationMedia: Ubuntu-Server 16.10 "Yakkety Yak" - Release amd64 (20161012.1)
MachineType: Dell Inc. OptiPlex 755
ProcEnviron:
 LANGUAGE=en_US:en
 TERM=xterm
 PATH=(custom, no user)
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/vmlinuz-4.8.0-22-generic root=/dev/mapper/hostname--vg-root ro
SourcePackage: systemd
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 06/11/2012
dmi.bios.vendor: Dell Inc.
dmi.bios.version: A22
dmi.board.name: 0PU052
dmi.board.vendor: Dell Inc.
dmi.chassis.type: 15
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvrA22:bd06/11/2012:svnDellInc.:pnOptiPlex755:pvr:rvnDellInc.:rn0PU052:rvr:cvnDellInc.:ct15:cvr:
dmi.product.name: OptiPlex 755
dmi.sys.vendor: Dell Inc.

Martin Pitt (pitti) wrote :

Please attach your networkd config so that I can reproduce this.

Did you report this crash via Apport (the crash notification/reporting system)? If you do, please check if you can find a stack trace.

Changed in systemd (Ubuntu):
status: New → Incomplete

This is auto uploaded by "ubuntu-bug", i've ran the systemd-networkd in debug mode, didn't give any more output.

Martin Pitt (pitti) wrote :

Thanks for forwarding this upstream! I cherry-picked the patch.

Changed in systemd (Ubuntu):
status: Incomplete → Fix Committed
description: updated
Changed in systemd (Ubuntu Zesty):
status: New → Fix Committed
Changed in systemd (Ubuntu Yakkety):
status: Fix Committed → In Progress
Martin Pitt (pitti) on 2016-10-18
Changed in systemd (Ubuntu Xenial):
status: New → In Progress

Will this fix be backported to Yakkety and possibly also Xenial as well?

Martin Pitt (pitti) wrote :

Yes to both; I already did that, it'll be part of the next SRUs.

Nice! Thanks for all help. When can i expect the SRU to be released?

Any idea when?

Martin Pitt (pitti) wrote :

I uploaded xenial and yakkety SRUs to the review queues, thus "soon".

Hello Halvor, or anyone else affected,

Accepted systemd into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/systemd/229-4ubuntu12 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in systemd (Ubuntu Xenial):
status: In Progress → Fix Committed
tags: added: verification-needed
Andy Whitcroft (apw) wrote :

Hello Halvor, or anyone else affected,

Accepted systemd into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/systemd/231-9ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in systemd (Ubuntu Yakkety):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 231-10

---------------
systemd (231-10) unstable; urgency=medium

  [ Martin Pitt ]
  * systemctl: Add --wait option to wait until started units terminate again.
  * nss-resolve: return NOTFOUND instead of UNAVAIL on resolution errors.
    This makes it possible to configure a fallback to "dns" without breaking
    DNSSEC, with "resolve [!UNAVAIL=return] dns".
  * libnss-resolve.postinst: Skip dns fallback if resolve is present.
    Only fall back to "dns" if nss-resolve is not installed (for the
    architecture of the calling program). Once it is, we never want to fall
    back to "dns" as that breaks enforcing DNSSEC verification and also
    pointlessly retries NXDOMAIN failures. (LP: #1624071)
  * unit: sent change signal before removing the unit if necessary
    (LP: #1632964)
  * networkd: Fix assertion crash on adding VTI with IPv6 addresses
    (LP: #1633274)
  * debian/tests/upstream: Stop specifying initrd, it is autodetected now.
  * debian/tests/upstream: Add gcc/libc-dev/make test dependencies,
    so that the tests can build helper binaries.

  [ Felipe Sateler ]
  * Explicitly disable installing the upstream-provided PAM configuration.
  * Register interest in the status of dracut and initramfs-tools in reportbug
    template

  [ Michael Biebl ]
  * Stop creating systemd-update-utmp-runlevel.service symlinks manually

 -- Martin Pitt <email address hidden> Wed, 26 Oct 2016 13:24:37 +0200

Changed in systemd (Ubuntu Zesty):
status: Fix Committed → Fix Released

Tested this on Ubuntu Yakkety, using the systemd package provided in the yakkety-proposed repository, it fixes the bug. Everything works as expected.

The package that fixed this was version: 231-9ubuntu1

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 229-4ubuntu12

---------------
systemd (229-4ubuntu12) xenial; urgency=medium

  * unit: sent change signal before removing the unit if necessary
    (LP: #1632964)
  * networkd: Fix assertion crash on adding VTI with IPv6 addresses
    (LP: #1633274)
  * systemd-networkd-resolvconf-update.service: Propagate search domains
    (LP: #1635256)

 -- Martin Pitt <email address hidden> Wed, 26 Oct 2016 13:18:42 +0200

Changed in systemd (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for systemd has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 231-9ubuntu1

---------------
systemd (231-9ubuntu1) yakkety; urgency=medium

  * debian/gbp.conf: Switch to yakkety branch
  * unit: sent change signal before removing the unit if necessary
    (LP: #1632964)
  * networkd: Fix assertion crash on adding VTI with IPv6 addresses
    (LP: #1633274)

 -- Martin Pitt <email address hidden> Wed, 26 Oct 2016 13:11:33 +0200

Changed in systemd (Ubuntu Yakkety):
status: Fix Committed → Fix Released
Changed in systemd:
status: Unknown → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.